'use strict';

exports.__esModule = true;

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

/**
 * @category layout
 * @component accordion
 * @variations collab-ui-react
 */

var AccordionMenu = function (_React$Component) {
  (0, _inherits3.default)(AccordionMenu, _React$Component);

  function AccordionMenu() {
    var _temp, _this, _ret;

    (0, _classCallCheck3.default)(this, AccordionMenu);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return _ret = (_temp = (_this = (0, _possibleConstructorReturn3.default)(this, _React$Component.call.apply(_React$Component, [this].concat(args))), _this), _this.state = {
      activeIndices: _this.props.initialActive || [],
      focus: false
    }, _this.verifyChildren = function () {
      var children = _this.props.children;

      var childrenArr = _react2.default.Children.toArray(children);

      var status = childrenArr.reduce(function (status, child) {
        return status && child.type.displayName === 'AccordionGroup';
      }, true);

      return children && childrenArr.length && status;
    }, _this.determineInitialFocus = function () {
      var nonDisabledIndex = _react2.default.Children.toArray(_this.props.children).reduceRight(function (agg, child, idx) {
        return !child.props.disabled ? idx : agg;
      }, null);

      _this.setFocus(nonDisabledIndex);
    }, _this.handleClick = function (index) {
      return _this.props.multipleVisible ? _this.setMultiple(index) : _this.setSelected(index);
    }, _this.setMultiple = function (index) {
      var newValues = void 0;
      var onSelect = _this.props.onSelect;
      var activeIndices = _this.state.activeIndices;

      var isActive = activeIndices.includes(index);

      if (isActive) {
        newValues = activeIndices.filter(function (v) {
          return v !== index;
        });
      } else {
        newValues = activeIndices.concat(index);
      }

      _this.setFocus(index);
      _this.setState(function () {
        onSelect && onSelect(newValues);
        return { activeIndices: newValues };
      });
    }, _this.setSelected = function (index) {
      var activeIndices = _this.state.activeIndices;
      var _this$props = _this.props,
          children = _this$props.children,
          onSelect = _this$props.onSelect;
      // Don't do anything if index is the same or outside of the bounds

      if (activeIndices.includes(index) || index < 0 || index >= children.length) return;

      // Keep reference to last index for event handler
      var last = activeIndices[0];

      // Update state with selected index
      _this.setState(function () {
        return { activeIndices: [index] };
      });
      _this.setFocus(index);

      onSelect && onSelect(index, last);
    }, _this.handleKeyPress = function (e, idx, length, disabled) {
      if (disabled) {
        e.preventDefault();
        e.stopPropagation();
        return;
      }

      var newIndex = void 0,
          clickEvent = void 0;
      var tgt = e.currentTarget;
      var flag = false;

      var getNewIndex = function getNewIndex(currentIndex, change) {
        var getPossibleIndex = function getPossibleIndex() {
          if (currentIndex + change < 0) {
            return length;
          } else if (currentIndex + change > length) {
            return 0;
          }

          return currentIndex + change;
        };
        var possibleIndex = getPossibleIndex();
        return _react2.default.Children.toArray(_this.props.children)[possibleIndex].props.disabled ? getNewIndex(possibleIndex, change) : possibleIndex;
      };

      switch (e.which) {
        case 32:
        case 13:
          try {
            clickEvent = new MouseEvent('click', {
              view: window,
              bubbles: true,
              cancelable: true
            });
          } catch (err) {
            if (document.createEvent) {
              // DOM Level 3 for IE 9+
              clickEvent = document.createEvent('MouseEvents');
              clickEvent.initEvent('click', true, true);
            }
          }
          tgt.dispatchEvent(clickEvent);

          flag = true;
          break;

        case 38:
        case 37:
          newIndex = getNewIndex(idx, -1);
          _this.setFocus(newIndex);
          flag = true;
          break;

        case 39:
        case 40:
          newIndex = getNewIndex(idx, 1);
          _this.setFocus(newIndex);
          flag = true;
          break;

        case 33:
        case 36:
          _this.setFocus(0);
          flag = true;
          break;

        case 34:
        case 35:
          _this.setFocus(length);
          flag = true;
          break;
        default:
          break;
      }

      if (flag) {
        e.stopPropagation();
        e.preventDefault();
      }
    }, _this.setFocus = function (index) {
      _this.setState({ focus: index });
    }, _temp), (0, _possibleConstructorReturn3.default)(_this, _ret);
  }

  AccordionMenu.prototype.componentWillMount = function componentWillMount() {
    if (!this.verifyChildren()) {
      throw new Error('Accordion should contain one or more AccordionGroup as children.');
    }
  };

  AccordionMenu.prototype.componentDidMount = function componentDidMount() {
    this.determineInitialFocus();
  };

  AccordionMenu.prototype.render = function render() {
    var _this2 = this;

    var _props = this.props,
        children = _props.children,
        className = _props.className;
    var activeIndices = this.state.activeIndices;


    var setAccordionGroups = _react2.default.Children.map(children, function (child, idx) {
      return _react2.default.cloneElement(child, {
        isExpanded: !child.props.disabled && activeIndices.includes(idx),
        onClick: function onClick() {
          return _this2.handleClick(idx);
        },
        onKeyDown: function onKeyDown(e) {
          return _this2.handleKeyPress(e, idx, children.length - 1, child.props.disabled);
        },
        focus: _this2.state.focus === idx
      });
    });

    return _react2.default.createElement(
      'div',
      {
        className: 'cui-accordion' + ('' + (className && ' ' + className || ''))
      },
      setAccordionGroups
    );
  };

  return AccordionMenu;
}(_react2.default.Component);

AccordionMenu.displayName = 'AccordionMenu';
exports.default = AccordionMenu;


AccordionMenu.defaultProps = {
  children: null,
  multipleVisible: false,
  onSelect: null,
  initalActive: [],
  classname: ''
};

/**
* @name Default Accordion
* @description Accordions are useful.
*
* @category layout
* @component accordion
* @section default
*
* @js
import { AccordionHeader, AccordionGroup, AccordionContent, ListItem } from '@collab-ui/react';

export default class Default extends React.Component {
  render() {
    return (
      <div>
        <div className='row'>
          <h3>Single Open</h3>
          <Accordion>
            <AccordionGroup>
              <AccordionHeader>
                <div>Accordion 1</div>
              </AccordionHeader>
              <AccordionContent>
                <ListItem label='Content 1' />
              </AccordionContent>
            </AccordionGroup>
            <AccordionGroup>
              <AccordionHeader>
                <div>Accordion 2</div>
              </AccordionHeader>
              <AccordionContent>
                <ListItem label='Content 2' />
              </AccordionContent>
            </AccordionGroup>
          </Accordion>
          </div>
          <br></br>
          <div className='row'>
            <h3>Multiple Open</h3>
            <Accordion multipleVisible>
              <AccordionGroup>
                <AccordionHeader>
                  <div>Accordion 1</div>
                </AccordionHeader>
                <AccordionContent>
                  <ListItem label='Content 1' />
                </AccordionContent>
              </AccordionGroup>
              <AccordionGroup>
                <AccordionHeader>
                  <div>Accordion 2</div>
                </AccordionHeader>
                <AccordionContent>
                  <ListItem label='Content 2' />
                </AccordionContent>
              </AccordionGroup>
            </Accordion>
          </div>
          <br></br>
          <div className='row'>
            <h3>PreSelected Open</h3>
            <Accordion multipleVisible initialActive={[0]}>
              <AccordionGroup>
                <AccordionHeader>
                  <div>Accordion 1</div>
                </AccordionHeader>
                <AccordionContent>
                  <ListItem label='Content 1' />
                </AccordionContent>
              </AccordionGroup>
              <AccordionGroup>
                <AccordionHeader>
                  <div>Accordion 2</div>
                </AccordionHeader>
                <AccordionContent>
                  <ListItem label='Content 2' />
                </AccordionContent>
              </AccordionGroup>
            </Accordion>
          </div>
        </div>
    );
  }
}
**/

module.exports = exports['default'];