'use strict';

exports.__esModule = true;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _lodash = require('lodash');

var _ = _interopRequireWildcard(_lodash);

var _2 = require('./..');

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj.default = obj; return newObj; } }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

/**
 * @category controls
 * @component activity
 * @variations collab-ui-react
 */

var ActivityButton = function ActivityButton(props) {
  var type = props.type,
      large = props.large,
      onClick = props.onClick,
      disabled = props.disabled,
      className = props.className,
      ariaLabel = props.ariaLabel;


  return _react2.default.createElement(
    _2.Button,
    {
      className: 'cui-activity' + ('' + (!type.icon && ' cui-activity__' + type || '')) + ('' + (large && ' cui-activity--large' || '')) + ('' + (className && ' ' + className || '')),
      disabled: disabled,
      onClick: onClick,
      ariaLabel: ariaLabel || !type.icon && type || '',
      color: _.get(type, 'color')
    },
    type.icon ? type.icon : _react2.default.createElement(_2.Icon, { name: '' + type + (large ? '_36' : '_28') })
  );
};

ActivityButton.displayName = 'ActivityButton';

ActivityButton.defaultProps = {
  type: '',
  large: false,
  onClick: null,
  className: '',
  disabled: false,
  ariaLabel: ''
};

exports.default = ActivityButton;

/**
* @name Default ActivityButton
* @description Default ActivityButton.
*
* @category controls
* @component activityButton
* @section default
*
* @js

export default function ActivityButtonDefault() {
  return(
    <div className='row' style={{marginBottom: '1rem'}}>
      <div>Default</div>
      <div style={{margin: `16px`}}>
        <ActivityButton
          type='chat'
          ariaLabel='jlshjksfghjl'
          onClick={()=>{}}/>
        <ActivityButton
          type='camera'
          onClick={()=>{}}/>
        <ActivityButton
          type='meetings'
          onClick={()=>{}}/>
        <ActivityButton
          type='whiteboard'
          onClick={()=>{}}/>
        <ActivityButton
          type='files'
          onClick={()=>{}}/>
        <ActivityButton
          type='share-screen'
          onClick={()=>{}}/>
        <ActivityButton
          type='tasks'
          onClick={()=>{}}/>
      </div>
    </div>
  );
}

**/

/**
* @name ActivityButton with large
* @description ActivityButton with large class.
*
* @category controls
* @component activityButton
* @section large
*
* @js

export default function ActivityButtonLarge() {
  return(
    <div className='row' style={{marginBottom: '1rem'}}>
      <div>Default</div>
      <div style={{margin: `16px`}}>
        <ActivityButton
          type='chat'
          large
          onClick={()=>{}}/>
        <ActivityButton
          type='camera'
          large
          onClick={()=>{}}/>
        <ActivityButton
          type='meetings'
          large
          onClick={()=>{}}/>
        <ActivityButton
          type='whiteboard'
          large
          onClick={()=>{}}/>
        <ActivityButton
          type='files'
          large
          onClick={()=>{}}/>
        <ActivityButton
          type='share-screen'
          large
          onClick={()=>{}}/>
        <ActivityButton
          type='tasks'
          large
          onClick={()=>{}}/>
      </div>
    </div>
  );
}

**/

/**
* @name ActivityButton with custom
* @description ActivityButton with custom prop.
*
* @category controls
* @component activityButton
* @section custom
*
* @js

export default function ActivityButtonCustom() {
  return(
    <div className='row' style={{marginBottom: '1rem'}}>
      <div>Default</div>
      <div style={{margin: `16px`}}>
        <ActivityButton
          type={{
            color: 'mint',
            icon: <span className='icon icon-arrow-left_32'/>
          }}
          large
          onClick={()=>{}}/>
        <ActivityButton
          type={{
            color: 'red',
            icon: <span className='icon icon-keyboard_16'/>
          }}
          onClick={()=>{}}/>
      </div>
    </div>
  );
}

**/

module.exports = exports['default'];