'use strict';

exports.__esModule = true;

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

/**
 * @category layout
 * @component footer
 * @variations collab-ui-react
 */

var Footer = function (_React$Component) {
  (0, _inherits3.default)(Footer, _React$Component);

  function Footer() {
    (0, _classCallCheck3.default)(this, Footer);
    return (0, _possibleConstructorReturn3.default)(this, _React$Component.apply(this, arguments));
  }

  Footer.prototype.render = function render() {
    var _props = this.props,
        logo = _props.logo,
        copyright = _props.copyright,
        social = _props.social,
        children = _props.children;

    var footerTopSection = children && _react2.default.createElement(
      'section',
      { className: 'cui-footer__top' },
      children
    );
    var footerBottomSection = (logo || copyright || social) && _react2.default.createElement(
      'section',
      { className: 'cui-footer__bottom' },
      (logo || copyright) && _react2.default.createElement(
        'span',
        { className: 'cui-footer__bottom--position-left' },
        logo,
        ' ',
        copyright
      ),
      social && _react2.default.createElement(
        'span',
        { className: 'cui-footer__bottom--position-right' },
        social
      )
    );

    return _react2.default.createElement(
      'footer',
      { className: 'cui-footer' },
      footerTopSection,
      footerBottomSection
    );
  };

  return Footer;
}(_react2.default.Component);

Footer.displayName = 'Footer';
exports.default = Footer;


Footer.defaultProps = {
  logo: null,
  copyright: '',
  social: '',
  children: null
};

/**
* @name Footer
* @description default footer
*
* @category layout
* @component footer
* @section default
*
* @js
import { Icon, List, ListItem } from '@collab-ui/react';

export default class DefaultFooter extends React.PureComponent {
  render() {
    const copyright = '2018 Cisco and /or its affiliate';

    return (
      <div className='row'>
        <Footer
          logo={<Icon name='icon-spark_16' />}
          copyright=''
          social=''
        >
          <div className='columns medium-3'>
            <h5 className='cui-footer__list-item-title'>Connect</h5>
            <List>
              <ListItem label='24/7 Support' />
              <ListItem label='Developer Events' />
              <ListItem label='Contact Sales' />
            </List>
          </div>
          <div className='columns medium-3'>
            <h5 className='cui-footer__list-item-title'>Handy Links</h5>
            <List>
              <ListItem label='Cisco Webex Ambassadors' />
              <ListItem label='Cisco Webex Control Hub' />
              <ListItem label='Cisco Webex Innovation Fund' />
            </List>
          </div>
          <div className='columns medium-3'>
            <h5 className='cui-footer__list-item-title'>Resources</h5>
            <List>
              <ListItem label='Open Source Bot Starter Kits' />
              <ListItem label='Download Cisco Webex Teams' />
              <ListItem label='Devnet Learning Labs' />
            </List>
          </div>
          <div className='columns medium-3'>
            <List>
              <ListItem label='Terms Of Service' />
              <ListItem label='Privacy Policy' />
              <ListItem label='Cookie Policy' />
              <ListItem label='Trademarks' />
            </List>
          </div>
        </Footer>
      </div>
    );
  }
}
**/

module.exports = exports['default'];