'use strict';

exports.__esModule = true;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

/**
 * @category communication
 * @component loading-spinner
 * @variations collab-ui-react
 */

var _ref = _react2.default.createElement('span', { className: 'cui-loading__icon' });

var _ref2 = _react2.default.createElement('span', { className: 'cui-loading__icon' });

var _ref3 = _react2.default.createElement('span', { className: 'cui-loading__icon' });

var Loading = function Loading(props) {
  var small = props.small;


  return _react2.default.createElement(
    'div',
    { className: 'cui-loading ' + (small ? 'cui-loading--small' : '') },
    _ref,
    _ref2,
    _ref3
  );
};

Loading.defaultProps = {
  small: false
};

Loading.displayName = 'Loading';

exports.default = Loading;

/**
* @name Default Loading
* @description Loadings are useful.
*
* @category communication
* @component loader-spinner
* @section default
*
* @js

import {Loading} from '@collab-ui/react';

export default function Default() {
  return (
    <div>
      <div style={{fontSize: '1rem', display: 'flex'}}>
        <Loading />
      </div>
      <div style={{fontSize: '2rem', display: 'flex'}}>
        <Loading />
      </div>
      <div style={{fontSize: '3rem', display: 'flex'}}>
        <Loading />
      </div>
    </div>
  );
}

**/

module.exports = exports['default'];