'use strict';

exports.__esModule = true;

var _extends2 = require('babel-runtime/helpers/extends');

var _extends3 = _interopRequireDefault(_extends2);

var _objectWithoutProperties2 = require('babel-runtime/helpers/objectWithoutProperties');

var _objectWithoutProperties3 = _interopRequireDefault(_objectWithoutProperties2);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

/**
 * @category containers
 * @component modal
 * @variations collab-ui-react
 */

var ModalBody = function ModalBody(props) {
  var className = props.className,
      other = (0, _objectWithoutProperties3.default)(props, ['className']);


  return _react2.default.createElement(
    'div',
    (0, _extends3.default)({ className: 'cui-modal__body' + ('' + (className && ' ' + className || ''))
    }, other),
    props.children
  );
};

ModalBody.defaultProps = {
  children: null,
  className: ''
};

ModalBody.displayName = 'ModalBody';

exports.default = ModalBody;

/**
* @name Modal Body
*
* @category containers
* @component modal
* @section Modal Body
*
* @js

import {
  Input,
  ModalBody
} from '@collab-ui/react';

export default function Default() {
    return (
      <div className='row'>
        <br />
        <ModalBody>
          <Input
            htmlId='testMe2'
            value='testMe2'
            name='testMe2'
            label='First Input'
            disabled
            placeholder='Disabled Input'
            onChange={() => {}}
            inputHelpText='Field Must be Disabled'
            errorArr={[]}
          />
        </ModalBody>
      </div>
    );
  }

**/

module.exports = exports['default'];