'use strict';

exports.__esModule = true;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

/**
 * @category containers
 * @component modal
 * @variations collab-ui-react
 */

var ModalFooter = function ModalFooter(props) {
  var className = props.className,
      children = props.children;

  return _react2.default.createElement(
    'div',
    { className: 'cui-modal__footer' + ('' + (className && ' ' + className || ''))
    },
    children
  );
};

ModalFooter.defaultProps = {
  children: null,
  className: ''
};

ModalFooter.displayName = 'ModalFooter';

exports.default = ModalFooter;

/**
* @name Modal Footer
*
* @category containers
* @component modal
* @section Modal Footer
*
* @js

import {
  Button,
  ModalFooter
} from '@collab-ui/react';

export default function Default() {
  return (
    <div className='row'>
      <br />
      <ModalFooter>
        <Button
          label='Cancel'
          onClick={()=>{}}
          ariaLabel='Close Modal'
          color='default'
        />
        <Button
          label='OK'
          onClick={()=>{}}
          ariaLabel='Submit Form'
          color='primary'
        />
      </ModalFooter>
    </div>
  );
}

**/

module.exports = exports['default'];