'use strict';

exports.__esModule = true;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

/**
 * Tabheader is used for Large Tabs with subheadings;
 * @param props
 * @returns {XML}
 * @constructor
 */

var TabHeader = function TabHeader(props) {
  var heading = props.heading,
      subHeading = props.subHeading;


  return (
    //Element type requires by UI-Collab Style
    _react2.default.createElement(
      'cui-tab-heading',
      null,
      heading,
      subHeading && _react2.default.createElement(
        'div',
        null,
        subHeading
      )
    )
  );
};

TabHeader.defaultProps = {
  subHeading: ''
};

TabHeader.displayName = 'TabHeader';

exports.default = TabHeader;
module.exports = exports['default'];