'use strict';

exports.__esModule = true;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

/**
 * Tab is supplemental, non-clickable component used to help bring attention to an item or object.
 * @param props
 * @returns {XML}
 * @constructor
 */
var TabPane = function TabPane(props) {
  var children = props.children,
      active = props.active;


  return _react2.default.createElement(
    'div',
    { className: 'cui-tab__pane' + ('' + (active ? ' active' : '')) },
    _react2.default.createElement(
      'div',
      { className: 'cui-tab__content' },
      children
    )
  );
};

TabPane.defaultProps = {
  active: false
};

TabPane.displayName = 'TabPane';

exports.default = TabPane;
module.exports = exports['default'];